Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMScenarioReqCombinationsCreator.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMScenarioReqCombinationsCreator.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMScenarioReqCombinationsCreator.java	(revision 1632)
@@ -16,4 +16,5 @@
 import org.openmodelica.modelicaml.common.instantiation.TreeObject;
 import org.openmodelica.modelicaml.common.instantiation.TreeParent;
+import org.openmodelica.modelicaml.common.services.ModelicaMLServices;
 import org.openmodelica.modelicaml.helper.datacollection.VerificationScenariosCollector;
 import org.openmodelica.modelicaml.helper.generators.CreatorValueBinding;
@@ -44,5 +45,5 @@
 	 * verification scenario that is used to stimulate the system model
 	 */
-	private Element testScenario;
+	private Element scenario;
 
 
@@ -51,5 +52,5 @@
 	 * All required models that are referenced (directly or indirectly) by the verification scenario model 
 	 */
-	private HashSet<Element> requiredModels_testScenario = new HashSet<Element>();
+	private HashSet<Element> requiredModels_scenario = new HashSet<Element>();
 	
 	/*
@@ -93,6 +94,10 @@
 
 	// contains tree objects (instantiation roots of models) with all mandatory clients that are NOT satisfied.
-	private HashMap<TreeParent, HashSet<TreeObject>> requiredClients_unsatisfied = new HashMap<TreeParent, HashSet<TreeObject>>();
-
+	private HashMap<TreeParent, HashSet<TreeObject>> mandatoryClients_unsatisfied = new HashMap<TreeParent, HashSet<TreeObject>>();
+
+	// models and their clients.
+	private HashMap<TreeParent, HashSet<TreeObject>>  modelClients = new HashMap<TreeParent, HashSet<TreeObject>> ();
+	
+	
 	// collector of verification data (scenarios, requirements etc.)
 	private VerificationScenariosCollector collector;
@@ -114,5 +119,5 @@
 	
 	public VeMScenarioReqCombinationsCreator(Class systemModel, 
-			Class testScenario, 
+			Class scenario, 
 			HashSet<Element> requirements,
 			Package valueMediatorsPackage,
@@ -125,5 +130,5 @@
 		
 		this.systemModel = systemModel;
-		this.testScenario = testScenario;
+		this.scenario = scenario;
 		this.requirements = requirements;
 		this.valueMediatorsPackage = valueMediatorsPackage;
@@ -146,10 +151,10 @@
 		 */
 		initialSetOfModels.add(systemModel);
-		initialSetOfModels.add(testScenario);
+		initialSetOfModels.add(scenario);
 		initialSetOfModels.addAll(requirements);
 		
 		// collect all models that are required in addition (deep search)
 		requiredModels_systemModel.addAll(findAdditionModels(systemModel));
-		requiredModels_testScenario.addAll(findAdditionModels(testScenario));
+		requiredModels_scenario.addAll(findAdditionModels(scenario));
 		
 		for (Element requirement : requirements) {
@@ -306,22 +311,32 @@
 		// Note, isDiscarded is false by default. There is no need to set it to false.
 		TreeParent systemModelInstantiationTreeRoot = modelToItsInstantiation.get(this.systemModel).getTreeRoot();
-		TreeParent testScenarioInstantiationTreeRoot = modelToItsInstantiation.get(this.testScenario).getTreeRoot();
-		
-		if (systemModelInstantiationTreeRoot != null && testScenarioInstantiationTreeRoot != null) {
-			if (!areAllRequiredClientsSatisfied(virtualInstantiationTreeRoot, systemModelInstantiationTreeRoot)) {
-
+		TreeParent scenarioInstantiationTreeRoot = modelToItsInstantiation.get(this.scenario).getTreeRoot();
+		
+		if (systemModelInstantiationTreeRoot != null && scenarioInstantiationTreeRoot != null) {
+			
+			if (!areAllMandatoryClientsSatisfied(virtualInstantiationTreeRoot, systemModelInstantiationTreeRoot)) {
+
+				// discard this combination
 				setDiscarded(true);
+				
 				String message = "DISCARDED(02): The combination " +
-						"\n   - Scenario: '" + ((NamedElement)this.testScenario).getQualifiedName() + "'" +
+						"\n   - Scenario: '" + ((NamedElement)this.scenario).getQualifiedName() + "'" +
 						"\n   - System Model: '" + ((NamedElement)this.systemModel).getQualifiedName() + "'" +
 						"\nis discarded because the following mandatory clients of the system model are not satisfied: " +
-						"\n" + getClientsDotPathAsString(requiredClients_unsatisfied.get(systemModelInstantiationTreeRoot));
+						"\n" + getClientsDotPathAsString(mandatoryClients_unsatisfied.get(systemModelInstantiationTreeRoot));
 				addToLog(message);
 			}
-			if (!isAtLeastOneProviderUsed(virtualInstantiationTreeRoot, testScenarioInstantiationTreeRoot)) {
-				
+			/*
+			 * TODO: What if all clients of the system model are satisfied by additional models, which in 
+			 * turn are satisfied by scenarios? Then the code below would discard this combination.
+			 * Should we consider this case?
+			 */
+			if (!isAtLeastOneProviderUsed(virtualInstantiationTreeRoot, scenarioInstantiationTreeRoot)) {
+				
+				// discard this combination
 				setDiscarded(true);
+				
 				String message = "DISCARDED(03): The combination " +
-						"\n   - Scenario: '" + ((NamedElement)this.testScenario).getQualifiedName() + "'" +
+						"\n   - Scenario: '" + ((NamedElement)this.scenario).getQualifiedName() + "'" +
 						"\n   - System Model: '" + ((NamedElement)this.systemModel).getQualifiedName() + "'" +
 						"\nis discarded because none of the scenario providers is used to stimulate the model. ";
@@ -346,14 +361,34 @@
 		
 		for (Element requirement : requirements) {
+			
 			TreeParent requirementInstantiationTreeRootItem = modelToItsInstantiation.get(requirement).getTreeRoot();
+			
 			if (requirementInstantiationTreeRootItem != null) {
+
 				// this method validates and collects the unsatisfied mandatory clients at the same time.
-				areAllRequiredClientsSatisfied(virtualInstantiationTreeRoot, requirementInstantiationTreeRootItem);
+				areAllMandatoryClientsSatisfied(virtualInstantiationTreeRoot, requirementInstantiationTreeRootItem);
+				
+				/*
+				 * check if if requirement has clients at all and all mandatory are satisfied
+				 */
 				
 				// add unsatisfied mandatory clients to log
-				if (getUnsatisfiedRequiredClients(requirement) != null) {
-					String message = "PROBLEM(05): Requirement " + ((NamedElement)requirement).getQualifiedName() + "'" +
+				HashSet<TreeObject> unsatisfiedClients = getUnsatisfiedMandatoryClients(requirement); 
+				if (unsatisfiedClients != null) {
+					String message = "PROBLEM(05): Requirement " 
+							+ ModelicaMLServices.getRequirementID(requirement) + ": " 
+							+ ModelicaMLServices.getName(requirement) 
+							+ " (" + ((NamedElement)requirement).getQualifiedName() + ")" +
 					"\n has the following mandatory clients which are not satisfied: " +
-					"\n" +getClientsDotPathAsString(getUnsatisfiedRequiredClients(requirement));
+					"\n" +getClientsDotPathAsString(unsatisfiedClients);
+					
+					addToLog(message);
+				}
+				else if (getModelClients(requirement) == null) {
+					String message = "PROBLEM(05.1): Requirement " 
+							+ ModelicaMLServices.getRequirementID(requirement) + ": " 
+							+ ModelicaMLServices.getName(requirement) 
+							+ " (" + ((NamedElement)requirement).getQualifiedName() + ")" +
+					"\n has no clients at all.";
 					
 					addToLog(message);
@@ -400,8 +435,9 @@
 	
 	
-	private boolean areAllRequiredClientsSatisfied(TreeParent virtualInstantiationTreeRoot, TreeParent treeParentToStartTheCheckOn){
+	private boolean areAllMandatoryClientsSatisfied(TreeParent virtualInstantiationTreeRoot, TreeParent treeParentToStartTheCheckOn){
 		
 		/* 
-		 * Get the list of clients for which the code could be derived (even if a user interaction would be necessary) 
+		 * Get the list of clients for which the code could be derived 
+		 * (even if a user interaction would be necessary) 
 		*/
 		CreatorValueBinding vbc = new CreatorValueBinding();
@@ -409,29 +445,84 @@
 		// pass the pre-collected mediators in oder to avoid searching once again 
 		vbc.setAllMediators(collector.getAllMediators()); 
+		
+		
+		boolean allMandatoryClientsAreSatisfied = false;
 		
 		/* Note, the updateAllBindings() is called with the last argument simulateOnly = true  
 		 * so that no modifications are created in components because we only want to analyze possible bindings.
 		 */
-		boolean allRequiredClientsAreSatisfied = true;
-		
 		// TODO: check the performance 
 		vbc.updateAllBindings(valueMediatorsPackage, null, treeParentToStartTheCheckOn, virtualInstantiationTreeRoot, false, true, false, true);
 		
-		if ( vbc.getAllRequiredClientsFound().size() > 0 
-				&& !vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllRequiredClientsFound())) {
-			allRequiredClientsAreSatisfied = false;
+		/*
+		 * If there are no clients at all: This case is considered 
+		 * being not a valid combination.
+		 */
+		HashSet<TreeObject> allClients = vbc.getAllClientsFound();  
+		
+		if (allClients == null || allClients.size() == 0) {
+			return false;
+		}
+		/*
+		 * Collect all models that have clients in order to be able to
+		 * determine if, for example, a requirement should be discarded because it has no clients at all.  
+		 */
+		else if (allClients != null){
+			modelClients.put(treeParentToStartTheCheckOn, allClients);
+		}
+		
+
+		// check if all mandatory clients are satisfied
+		if ( vbc.getAllMandatoryClientsFound().size() > 0 
+				&& vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllMandatoryClientsFound())) {
+			allMandatoryClientsAreSatisfied = true;
+		}
+		else if (vbc.getAllClientsFound().size() > 0) {
+			/*
+			 * If there are optional clients then we conclude that all mandatory are satisfied.
+			 * After that we will check of at least one client is used from the scenario. 
+			 * This is used in order to avoid rejecting of combinations in which 
+			 * the system model has only optional clients. 
+			 */
+			allMandatoryClientsAreSatisfied = true;
 		}
 		
 		// Collect all mandatory clients that are not satisfied.
 		HashSet<TreeObject> unsatisfiedRequiredClients = new HashSet<TreeObject>();
-		unsatisfiedRequiredClients.addAll(vbc.getAllRequiredClientsFound());
+		unsatisfiedRequiredClients.addAll(vbc.getAllMandatoryClientsFound());
 		unsatisfiedRequiredClients.removeAll(vbc.getAllClientsWithPossibleBindingCodeDerivation());
 
 		if (unsatisfiedRequiredClients.size() > 0 ) {
-			requiredClients_unsatisfied.put(treeParentToStartTheCheckOn, unsatisfiedRequiredClients);
-		}
-		
-		return allRequiredClientsAreSatisfied;
-	}
+			mandatoryClients_unsatisfied.put(treeParentToStartTheCheckOn, unsatisfiedRequiredClients);
+		}
+		
+		if (!allMandatoryClientsAreSatisfied) {
+			System.err.println("HIER");
+		}
+		
+		return allMandatoryClientsAreSatisfied;
+	}
+	
+	
+//	private boolean hasClients(TreeParent virtualInstantiationTreeRoot, TreeParent treeParentToStartTheCheckOn){
+//		
+//		/* 
+//		 * Get the list of clients for which the code could be derived 
+//		 * (even if a user interaction would be necessary) 
+//		*/
+//		CreatorValueBinding vbc = new CreatorValueBinding();
+//		
+//		// pass the pre-collected mediators in oder to avoid searching once again 
+//		vbc.setAllMediators(collector.getAllMediators()); 
+//		
+//		
+//		/* Note, the updateAllBindings() is called with the last argument simulateOnly = true  
+//		 * so that no modifications are created in components because we only want to analyze possible bindings.
+//		 */
+//		// TODO: check the performance 
+//		vbc.updateAllBindings(valueMediatorsPackage, null, treeParentToStartTheCheckOn, virtualInstantiationTreeRoot, false, true, false, true);
+//		
+//		return vbc.getAllClientsFound().size() > 0;
+//	}
 	
 	
@@ -481,10 +572,10 @@
 	}
 	
-	public HashSet<Element> getAdditionalTestScenarioModels(boolean prune){
+	public HashSet<Element> getAdditionalScenarioModels(boolean prune){
 		if (!prune) {
-			return this.requiredModels_testScenario;
+			return this.requiredModels_scenario;
 		}
 		HashSet<Element> additionalModels = new HashSet<Element>();
-		for (Element additionalModel : this.requiredModels_testScenario) {
+		for (Element additionalModel : this.requiredModels_scenario) {
 			TreeParent additionalModelInstantiation = this.modelToItsInstantiation.get(additionalModel).getTreeRoot();
 			if (additionalModelInstantiation != null) {
@@ -530,10 +621,10 @@
 	// Utls **********************************************************************
 	
-	public HashSet<TreeObject> getUnsatisfiedRequiredClients(Element model){
+	public HashSet<TreeObject> getUnsatisfiedMandatoryClients(Element model){
 		if (model != null) {
 			TreeParent modelInstantiation = modelToItsInstantiation.get(model).getTreeRoot();
 			
 			if (modelInstantiation != null) {
-				HashSet<TreeObject> unsatisfiedClients = requiredClients_unsatisfied.get(modelInstantiation);
+				HashSet<TreeObject> unsatisfiedClients = mandatoryClients_unsatisfied.get(modelInstantiation);
 
 				if (unsatisfiedClients != null && unsatisfiedClients.size() > 0 ) {
@@ -545,4 +636,20 @@
 	}
 	
+	
+	public HashSet<TreeObject> getModelClients(Element model) {
+		if (model != null) {
+			TreeParent modelInstantiation = modelToItsInstantiation.get(model).getTreeRoot();
+		
+			if (modelInstantiation != null) {
+				HashSet<TreeObject> allClients = modelClients.get(modelInstantiation);
+
+				if (allClients != null && allClients.size() > 0 ) {
+					return allClients;
+				}
+			}
+		}
+		return null;
+	}
+
 	
 	
@@ -618,5 +725,5 @@
 		"--------------------------------------------------- \n" +
 		"Log for the combination:" +
-			"\n   - Scenario '" + ((NamedElement)this.testScenario).getQualifiedName() + "'" +
+			"\n   - Scenario '" + ((NamedElement)this.scenario).getQualifiedName() + "'" +
 			"\n   - System Model '" + ((NamedElement)this.systemModel).getQualifiedName() + "'" +
 			"\n";
@@ -634,5 +741,5 @@
 	
 	public Element getTestScenario() {
-		return testScenario;
+		return scenario;
 	}
 	
@@ -645,6 +752,6 @@
 	}
 
-	public HashSet<Element> getRequiredModels_testScenario() {
-		return requiredModels_testScenario;
+	public HashSet<Element> getRequiredModels_scenario() {
+		return requiredModels_scenario;
 	}
 
@@ -684,5 +791,5 @@
 
 	public HashMap<TreeParent, HashSet<TreeObject>> getRequiredClients_unsatisfied() {
-		return requiredClients_unsatisfied;
+		return mandatoryClients_unsatisfied;
 	}
 
@@ -712,3 +819,4 @@
 		return alwaysInclude;
 	}
+
 }
Index: /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/helper/ModelicaMLElementsCreator.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/helper/ModelicaMLElementsCreator.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/helper/ModelicaMLElementsCreator.java	(revision 1632)
@@ -702,19 +702,23 @@
 			@Override
 			protected void doExecute() {
-				createdElement = sourceClass.createDependency(targetClass);
-				
-				Stereotype s = createdElement.getApplicableStereotype(StereotypeQname);
-				if (s != null) {
-					createdElement.applyStereotype(s);
-					if (treeObject instanceof ImportRelationItem) {
-						ImportRelationItem importRelationItem = (ImportRelationItem) treeObject;
-						((Dependency)createdElement).setName(importRelationItem.getSourceQname() + " imports " + importRelationItem.getTargetQname());
-						createdElement.setValue(s, Constants.propertyName_alias, importRelationItem.getAlias());
-					}
-				}
-				else {
-					addToLog("Could not apply the import stereotype to the element '" + treeObject.getQName() + "'");
-				}
-				
+				
+				// prevent cyclic dependencies
+				if (sourceClass.equals(targetClass)) {
+					
+					createdElement = sourceClass.createDependency(targetClass);
+					
+					Stereotype s = createdElement.getApplicableStereotype(StereotypeQname);
+					if (s != null) {
+						createdElement.applyStereotype(s);
+						if (treeObject instanceof ImportRelationItem) {
+							ImportRelationItem importRelationItem = (ImportRelationItem) treeObject;
+							((Dependency)createdElement).setName(importRelationItem.getSourceQname() + " imports " + importRelationItem.getTargetQname());
+							createdElement.setValue(s, Constants.propertyName_alias, importRelationItem.getAlias());
+						}
+					}
+					else {
+						addToLog("Could not apply the import stereotype to the element '" + treeObject.getQName() + "'");
+					}
+				}
 			}
 		};
@@ -762,5 +766,5 @@
 				Element target = treeBuilder.getTypeElement(extendsRelation.getTargetQname());
 				
-				TreeParent owningClass = extendsRelation.getParent();
+				TreeParent owningClassItem = extendsRelation.getParent();
 				
 				/*
@@ -769,6 +773,6 @@
 				 */
 				if (target instanceof Classifier 
-						&& !extendsRelation.getTargetQname().equals(extendsRelation.getSourceQname())
-						&& !extendsRelation.getTargetQname().equals(owningClass.getQName())
+						&& !extendsRelation.getTargetQname().equals(extendsRelation.getSourceQname()) 
+						&& !extendsRelation.getTargetQname().equals(owningClassItem.getQName()) // TODO: this should actually be the same like extendsRelation.getSourceQname() 
 						) {
 //					System.out.println("Creating extends relation: " + extendsRelationTreeObject.getSourceQname() + " -> " + extendsRelation.getTargetQname());
Index: /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/model/TreeBuilder.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/model/TreeBuilder.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.modelica.importer/src/org/openmodelica/modelicaml/modelica/importer/model/TreeBuilder.java	(revision 1632)
@@ -313,5 +313,4 @@
 			else {
 				// Create Import relations nodes
-//				System.err.println("Creating Import Relations in " + classQName);
 				createdItems.addAll(createImportRelationNodes(treeParent, classQName));
 				
@@ -320,6 +319,4 @@
 				if (inheritedClasses.size() > 0) {
 					for (String inheritedClassQName : inheritedClasses) {
-						
-//						System.err.println("Creating ExtendsRelationItem in " + classQName);
 						
 						setMonitorTaskName("Creating extends relations in " + inheritedClassQName);
@@ -1195,7 +1192,5 @@
 							ModelicaModelProxiesCollector pc = new ModelicaModelProxiesCollector();
 							pc.setStereotypeQName(Constants.stereotypeQName_ModelicaModelProxy);
-//							pc.collectElementsFromModel(root, Constants.stereotypeQName_ModelicaModelProxy);
 							pc.collectElementsFromModel(root);
-		//					proxies = pc.getElements();
 							proxies.addAll(pc.getElements());
 							
@@ -1208,5 +1203,4 @@
 							proxiesCopy.addAll(proxies);
 							
-		//					for (Element proxy : proxies) {
 							for (Element proxy : proxiesCopy) {
 								if (proxy instanceof NamedElement) {
@@ -1463,11 +1457,11 @@
 	}
 
-	public void setErrorLog(String errorLog) {
-		this.errorLog = errorLog;
-	}
-
-	private void addToErrorLog(String msg){
-		this.errorLog += "\n\n" + msg;
-	}
+//	public void setErrorLog(String errorLog) {
+//		this.errorLog = errorLog;
+//	}
+//
+//	private void addToErrorLog(String msg){
+//		this.errorLog += "\n\n" + msg;
+//	}
 	
 }
